'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DEFAULT_OPTS = exports.Opts = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _freeze = require('babel-runtime/core-js/object/freeze');

var _freeze2 = _interopRequireDefault(_freeze);

var _babelPluginTransformReactJsx = require('babel-plugin-transform-react-jsx');

var _babelPluginTransformReactJsx2 = _interopRequireDefault(_babelPluginTransformReactJsx);

var _babelPluginSyntaxJsx = require('babel-plugin-syntax-jsx');

var _babelPluginSyntaxJsx2 = _interopRequireDefault(_babelPluginSyntaxJsx);

var _babelPluginTransformReactDisplayName = require('babel-plugin-transform-react-display-name');

var _babelPluginTransformReactDisplayName2 = _interopRequireDefault(_babelPluginTransformReactDisplayName);

var _babelPluginTransformReactJsxSource = require('babel-plugin-transform-react-jsx-source');

var _babelPluginTransformReactJsxSource2 = _interopRequireDefault(_babelPluginTransformReactJsxSource);

var _babelPluginTransformReactJsxSelf = require('babel-plugin-transform-react-jsx-self');

var _babelPluginTransformReactJsxSelf2 = _interopRequireDefault(_babelPluginTransformReactJsxSelf);

var _reactIntl = require('../plugins/react-intl');

var _reactIntl2 = _interopRequireDefault(_reactIntl);

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Opts = exports.Opts = _flowRuntime2.default.type('Opts', _flowRuntime2.default.object(_flowRuntime2.default.property('reactIntl', _flowRuntime2.default.boolean())));

var DEFAULT_OPTS = exports.DEFAULT_OPTS = Opts.assert((0, _freeze2.default)({
  reactIntl: true
}));

exports.default = _flowRuntime2.default.annotate(function (context, opts) {
  var _contextType = _flowRuntime2.default.any();

  var _optsType = Opts;

  _flowRuntime2.default.param('context', _contextType).assert(context);

  _flowRuntime2.default.param('opts', _optsType).assert(opts);

  return {
    plugins: [
    // same as babel-preset-react except flow plugins (flow support is added separately see es.js)
    [_babelPluginTransformReactJsx2.default, { useBuiltIns: true }], _babelPluginSyntaxJsx2.default, _babelPluginTransformReactDisplayName2.default].concat((0, _toConsumableArray3.default)(process.env.NODE_ENV !== 'production' ? [_babelPluginTransformReactJsxSource2.default, _babelPluginTransformReactJsxSelf2.default] : []), [

    // react-intl support
    opts.reactIntl ? [_reactIntl2.default, { enforceDescriptions: false }] : null]).filter(Boolean)
  };
}, _flowRuntime2.default.function(_flowRuntime2.default.param('context', _flowRuntime2.default.any()), _flowRuntime2.default.param('opts', Opts)));